<template>
  <section class="mt-filter-liste" :class="theme">
    <article>
      <slot>
        <div
          v-if="afficherTotal & (indexSelected != null)"
          class="mt-filter-item-bis mt-filter-item-master"
          @click="selectAll"
        >
          <span class="has-text-weight-semibold">{{ libelleTotal }} ({{ fullsize }})</span>
        </div>
        <div
          v-if="afficherTotal & (indexSelected == null)"
          class="mt-filter-item mt-filter-item-master"
          @click="selectAll"
        >
          <span class="has-text-weight-semibold">{{ libelleTotal }} ({{ fullsize }})</span>
        </div>
      </slot>
    </article>
    <div>
      <article class="mt-filter-liste-groupe">
        <div class="columns">
          <b-dropdown v-if="groupes != null && groupes.length > 0" aria-role="list" class="column">
            <b-button
              slot="trigger"
              slot-scope="{ active }"
              :icon-right="active ? 'chevron-up' : 'chevron-down'"
              class="mt-groupe mt-groupe-button"
            >
              {{ groupeTitre }}
            </b-button>

            <b-dropdown-item aria-role="listitem" @click="unselecteGroupe">---</b-dropdown-item>
            <b-dropdown-item
              v-for="(groupeItem, index) in groupes"
              :key="index"
              aria-role="listitem"
              @click="selecteGroupe(groupeItem)"
            >
              <div class="columns">
                <div class="column">{{ groupeItem.nom }}</div>
                <div class="column is-narrow">
                  <mt-count-utilisateur :nombre="groupeItem.groupesPersonnaliserDetails.length"></mt-count-utilisateur>
                </div></div
            ></b-dropdown-item>
          </b-dropdown>

          <template v-for="(categorie, index) in categories">
            <div :key="`div${index}`" class="column">
              <mt-filtre-categorie-item
                :key="index"
                :index="index"
                :categorie="categorie"
                :selected="indexSelected"
                :label-properties="labelProperties"
                class="column"
                @select-categorie="toggleCategorie(categorie, index)"
              ></mt-filtre-categorie-item>
            </div>
          </template>
          <slot name="bas"></slot>
        </div>
      </article>
    </div>
  </section>
</template>

<script>
import MtFiltreCategorieItem from '~/components/filtre/filtre-categorie/filtre-categorie-item';
import MtCountUtilisateur from '~/components/pax/mt-count-utilisateur';

export default {
  name: 'MtFiltreCategorie',
  components: { MtCountUtilisateur, MtFiltreCategorieItem },
  props: {
    afficherTotal: Boolean,
    libelleTotal: {
      type: String,
      default: () => 'Pax disponibles',
    },
    theme: {
      type: String,
      default: 'bubble',
    },
    labelProperties: {
      type: String,
      default: 'libelle',
    },
    fullsize: {
      type: Number,
      default: () => 0,
    },
    categories: {
      type: Array,
      default: () => [],
    },
    groupes: {
      type: Array,
      default: () => [],
    },
    groupeSelected: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      indexSelected: null,
      groupe: null,
    };
  },
  computed: {
    groupeTitre() {
      if (!this.getGroupeSelected) {
        return 'Sélectionnez un groupe';
      }
      return this.getGroupeSelected.nom;
    },
    getGroupeSelected() {
      if (this.groupeSelected) {
        return this.groupeSelected;
      }
      return this.groupe;
    },
  },
  created() {
    this.groupe = this.groupeSelected;
  },
  methods: {
    toggleCategorie(categorie, index) {
      if (this.indexSelected === index) {
        this.selectAll();
      } else {
        this.$emit('select-categorie', categorie);
        this.indexSelected = index;
      }
    },

    selectAll() {
      this.$emit('select-all');
      this.indexSelected = null;
    },
    unselecteGroupe() {
      this.groupe = null;
      this.$emit('unselect-groupe');
    },
    selecteGroupe(groupe) {
      this.groupe = groupe;
      this.$emit('select-groupe', groupe);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-filter-liste {
  display: flex;
  justify-content: space-between;
  align-items: center;

  .b-checkbox {
    margin: 0.5rem 0;
  }

  .button.is-text {
    color: $primary;
  }

  .mt-filter-liste-groupe {
    display: flex;
  }

  & > article {
    display: flex;
  }

  &.bubble {
    /deep/ .mt-filter-item {
      border-radius: 2rem;
      background-color: $pale-grey;
      color: #666ee8;
      font-size: $size-7;
      padding: 0.5em 1em;
      margin: 0 0.25em;
      cursor: pointer;
      transition-property: background-color, color;
      transition-duration: 0.3s;

      &.selected,
      &.selected:hover {
        background-color: $primary;
        color: $white;
      }
      &:hover,
      &.mt-filter-item-master {
        background-color: $periwinkle-blue;
        color: white;
      }
      &.mt-filter-item-master {
        justify-self: flex-start;
      }
    }
  }

  &.bubble {
    /deep/ .mt-filter-item-bis {
      border-radius: 2rem;
      background-color: $pale-grey;
      color: #666ee8;
      font-size: $size-7;
      padding: 0.5em 1em;
      margin: 0 0.25em;
      cursor: pointer;
      transition-property: background-color, color;
      transition-duration: 0.3s;

      &.selected,
      &.selected:hover {
        background-color: $primary;
        color: $white;
      }
      &:hover,
      &.mt-filter-item-master {
        background-color: $pale-grey;
        color: #666ee8;
      }
      &.mt-filter-item-master {
        justify-self: flex-start;
      }
    }
  }

  &.onglet {
    .mt-filter-liste-groupe {
      justify-content: center;
      flex-grow: 1;
    }

    box-shadow: 0 1px 1px 0 rgba(100, 132, 241, 0.2);
    justify-content: stretch;

    /deep/ .mt-filter-item {
      flex-grow: 1;
      font-size: 0.875rem;
      padding: 0.5em 0.5em;
      cursor: pointer;
      transition-property: border-bottom-color, color;
      transition-duration: 0.3s;
      border-bottom: 1px solid transparent;
      text-align: center;

      &.selected,
      &.selected:hover {
        color: $primary;
        border-bottom-color: $primary;
        font-weight: bold;
      }

      &:hover,
      &.mt-filter-item-master {
        color: $periwinkle-blue;
        border-bottom-color: $periwinkle-blue;
      }
    }
  }
}
</style>
